// Initialize
global float chroma[12];
Chroma c;
JingleBells jb;

60000/90/8 => int updateFreq;

// Shared Variables
0 => global int count;
0 => global int verseOrChorus;
0 => global int proMode;
0 => global int proSelect;
0 => global int loopChord;
1 => global float masterGain;

// Edits
global Event edit;

// Counter to limit key updates
0 => int i;

spork ~ listenForEdits();

fun void listenForEdits()
{
    while (true)
    {
        edit => now;

        masterGain => jb.master.gain; // Set master gain
        verseOrChorus => jb.verseOrChorus; // Set verse or chorus
    }
}

while (true)
{

    // Get current count
    jb.count => count;  

    updateFreq::ms => now;

    // Chroma Updates
    c.getChroma() @=> chroma;

    // Change accompaniment
    if (proMode) 
    {
        jb.updateProJingle(proSelect);
    } 
    else 
    {
        if (i == 4)
        {
            // Update Jingle Bells every 2 counts
            jb.updateJingle(chroma); 
            0 => i;
        }
        i++;
    }

    // Get the loopIndex
    jb.loopIndex => loopChord;
}